import { PdfGanttTaskbarCollection } from './pdf-taskbar';
import { PageDetail } from '../base/interface';
import { PdfLayoutResult, PdfColor } from '@syncfusion/ej2-pdf-export';
import { Gantt } from '../base/gantt';
import { PdfTreeGrid } from './pdf-treegrid';
import { PdfTimeline } from './pdf-timeline';
import { PdfGanttPredecessor } from './pdf-connector-line';
import { EventMarker } from './pdf-event-marker';
/**
 *
 */
export declare class PdfGantt extends PdfTreeGrid {
    taskbarCollection: PdfGanttTaskbarCollection[];
    predecessorCollection: PdfGanttPredecessor[];
    private taskbars;
    private totalPages;
    private exportProps;
    private perColumnPages;
    private headerDetails;
    pdfPageDetail: PageDetail[];
    result: PdfLayoutResult;
    timelineStartDate: Date;
    private startPoint;
    private startPageIndex;
    borderColor: PdfColor;
    predecessor: PdfGanttPredecessor;
    chartHeader: PdfTimeline;
    chartPageIndex: number;
    eventMarker: EventMarker;
    changeCloneProjectDates: boolean;
    currentPage: number;
    parent: Gantt;
    constructor(parent: Gantt);
    readonly taskbar: PdfGanttTaskbarCollection;
    drawChart(result: PdfLayoutResult): void;
    private calculateRange;
    /**
     * Calculates the end date by adding the specified number of working hours to the current date,
     * excluding any non-working days as specified in the nonWorkingDayIndex.
     *
     * @param {Date} currentDate - The starting date from which to begin adding working hours.
     * @param {number} startHours - The number of hours to add to the current date.
     * @param {number} count - A multiplier to apply to the startHours, typically representing a scaling factor.
     * @returns {Date} - A new Date object representing the calculated date/time after working hours have been added.
     *
     */
    private calculateHoursWithoutNonworkingDays;
    /**
     * Calculates the end date by adding the specified number of working days to the current date,
     * excluding any non-working days as defined in the nonWorkingDayIndex.
     *
     * @param {Date} startDate - The starting date from which to begin adding working days.
     * @param {number} daysToAdd - The number of days to add to the current date.
     * @param {number} count - A multiplier applied to daysToAdd, typically representing the number of units.
     * @returns {Date} - A new Date object representing the calculated date after working days have been added.
     *
     */
    private calculateDaysWithoutNonworkingDays;
    private drawPageBorder;
    private drawGantttChart;
}
